<template>
  <router-link
    :class="{
      link: true,
      opened: opened
    }"
    :to="href"
  >
    <div class="icon">
      <Icon size="28px" :src="icon" :color="opened?'#FFFFFF':'var(--color)'"/>
    </div>
    <span>
      {{ caption }}
    </span>
  </router-link>
</template>

<script>
import Icon from "../Icon";

export default {
  components: { Icon },
  props: {
    href: {
      type: String,
      default: "#"
    },
    caption: {
      type: String,
      default: "Link"
    },
    icon: {
      type: String
    }
  },
  setup() {
    return {};
  },
  computed: {
    opened(){
      return this.$route.path == this.href;
    }
  }
};
</script>

<style scoped lang="scss">
.link {
  position: relative;
  display: flex;
  align-items: center;
  justify-content: flex-start;
  width: 200px;

  box-shadow: inset 0px 0px 0px #2D9CDB00;

  text-decoration: none;
  color: var(--color);

  &::after{
    content: "";
    position: absolute;
    display: block;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background: #2D9CDB;

    transition: 0.3s ease all;
    transform: translateX(-100%);
  }

  &:hover{
    &::after{
      transform: translateX(calc(-100% + 4px));
    }
  }

  &.opened{
    color: #FFFFFF;
    &::after{
      transform: translateX(0);
    }
  }
}
.icon{
  position: relative;
  width: 44px;
  height: 44px;
  z-index: 2;

  display: flex;
  justify-content: center;
  align-items: center;
}
span{
  position: relative;
  z-index: 2;
  margin-left: 8px;
}
</style>
